code_start = $1001

.org code_start-2
	.word code_start; for the .prg file

;BASIC:	 2003 sys4109

	.word :+,2003
	.byte $9e	; sys token
	.byte "4109"
:	.byte 0,0,0


p = $02

.proc	main

	sei
	sta $ff3f

	jsr copyFliData

	lda #<fliSpeedcode
	sta <p
	lda #>fliSpeedcode
	sta <(p+1)
	jsr makeFliSpeedcode

	lda $ff07
	and #$e0
	ora #$18
	sta $ff07

	lda #(bitmap/1024)
	sta $ff12

	jsr initIrq

	lda #0
	sta $ff19

	jmp *
.endproc

gr_mode_06 = $38

screen0 = $2000
screen1 = $2800
screen2 = $3000
screen3 = $3800

bitmap = $4000
ff15_tab = $6000



.proc	initIrq

	lda #$01
	sta $ff0b
	lda #$02
	sta $ff0a
	lda #<irq
	sta $fffe
	lda #>irq
	sta $ffff
	lda $ff09
	sta $ff09
	cli
	rts

irq:
	sta temp_a
	lda $ff1e	;stabilizaljuk a rasztert
	lsr
	lsr
	sta reljump
reljump = *+1
	bpl *+2
	cmp #$c9
	cmp #$c9
	cmp #$c9
	cmp #$c9
	cmp #$c9
	cmp #$c5
	nop
	; stabil!
	stx temp_x
	sty temp_y

	bit $ffff
	bit $ffff
	bit $ffff
	bit $ffff
	bit $ffff

	lda $fc
	pha
	lda $fd
	pha
	lda $fe
	pha
	lda $ff
	pha
	
	lda colorRamTab
	sta $fc
	lda colorRamTab+1
	sta $fd
	lda colorRamTab+2
	sta $fe
	lda colorRamTab+3
	sta $ff
	
	jsr fliSpeedcode

	lda ff06_tab
	sta $ff06
	
	pla
	sta $ff
	pla
	sta $fe
	pla
	sta $fd
	pla
	sta $fc


	lda $ff09
	sta $ff09
temp_a = *+1
	lda #0
temp_x = *+1
	ldx #0
temp_y = *+1
	ldy #0
	rti

.endproc



.proc	makeFliSpeedcode

	ldy #0
	sty ycount

c:	ldx #10
	tya
	and #1
	bne copy
	tya
	and #7
	lsr
	tax
	lda ff14_tab,x
	sta ff14r
	lda ff06_tab,x
	sta ff06r
	ldx #0
copy:	ldy #255
:	iny
	lda sample_beg,x
	sta (p),y
	inx
	cpx #<(sample_end-sample_beg)
	bne :-
	tya
	clc
	adc <p
	sta <p
	bcc :+
	inc <(p+1)

:	clc
	lda rff15
	adc #2
	sta rff15
	bcc :+
	inc rff15+1
:	clc
	lda rff15
	adc #1
	sta rff16
	lda rff15+1
	adc #0
	sta rff16+1

	inc ycount
ycount=*+1
	ldy #0 
	cpy #200
	bne c
	rts


sample_beg:

ff06r = *+1
	lda #00
ff14r = *+1
	ldy $00
	sta $ff06
	sty $ff14

rff15 = *+1
	lda ff15_tab
rff16 = *+1
	ldy ff15_tab+1
	sta $ff15
	sty $ff16

	rts

sample_end:

.endproc


ff06_tab: 
	.byte gr_mode_06 + 3
	.byte gr_mode_06 + 5
	.byte gr_mode_06 + 7
	.byte gr_mode_06 + 1

ff14_tab: .byte $fc, $fd, $fe, $ff


colorRamTab:
	.byte >screen0
	.byte >screen1
	.byte >screen2
	.byte >screen3


fliSpeedcode:


.proc	copyFliData

	lda #<fliData
	sta $d0
	lda #($43 + >fliData)
	sta $d1
	ldy #0
	sty $d2
	lda #$63
	sta $d3
	ldx #$44
l:	lda ($d0),y
	sta ($d2),y
	iny
	bne l
	dec $d1
	dec $d3
	dex
	bne l
	rts
.endproc


fliData: